package com.utopiaindustries.hseobservationsapp.activities.InjuryRecordForms;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;
import androidx.lifecycle.ViewModelProvider;

import com.utopiaindustries.hseobservationsapp.R;
import com.utopiaindustries.hseobservationsapp.utils.ProgressDialogFragment;
import com.utopiaindustries.hseobservationsapp.utils.StorageManager.StorageManager;
import com.utopiaindustries.hseobservationsapp.viewmodels.LoginViewModel;

public class InjuryFormOne extends AppCompatActivity {

    Button btnNext, btnFetch;
    LoginViewModel loginViewModel;
    EditText etEmpId, etEmployeeName, etEmployeeDesignation, etEmployeeTenure, etDate, etEmployeeType;
    ImageView imgBack;

    RadioGroup rg1;
    RadioButton rbEmployee, rbDailyWage;

    LinearLayout layoutEmployeeInfo, layoutDailyWageInfo;
    EditText etLocationSite, etCnic, etContractorName, etDivision, etName;
    TextView txtEmployeeHeading;
    String workerType = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_injury_form_one);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initializeLayouts();

        imgBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                alertExit(InjuryFormOne.this);
            }
        });

        btnFetch.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (workerType.equalsIgnoreCase("Visitor")) {
                    if (etEmpId.getText().toString().isEmpty()) {
                        Toast.makeText(InjuryFormOne.this, "Please enter visitor id", Toast.LENGTH_SHORT).show();
                        return;
                    }
                    loginViewModel.getDailyWageWorkerData(etEmpId.getText().toString());
                    StorageManager.getInstance().getInjuryRecordModel().get(0).setWorkerType("DailyWageWorker");
                }
                else {
                    if (etEmpId.getText().toString().isEmpty()) {
                        Toast.makeText(InjuryFormOne.this, "Please enter employee id", Toast.LENGTH_SHORT).show();
                        return;
                    }
                    loginViewModel.getEmployeeData(etEmpId.getText().toString());
                    StorageManager.getInstance().getInjuryRecordModel().get(0).setWorkerType("Employee/Contractor-Worker");
                }

            }
        });

        btnNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (isValidate()) {
                    StorageManager.getInstance().getInjuryRecordModel().get(0).setWorkerId(Integer.parseInt(etEmpId.getText().toString()));
                    Intent intent = new Intent(InjuryFormOne.this, InjuryFormTwo.class);
                    startActivity(intent);
                    overridePendingTransition(R.anim.slide_in_right, R.anim.slide_out_left);
                }

            }
        });

        rg1.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener()
        {
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if (checkedId == R.id.rb_employee) {
                    layoutEmployeeInfo.setVisibility(View.VISIBLE);
                    layoutDailyWageInfo.setVisibility(View.GONE);
                    txtEmployeeHeading.setText("Employee ID Number *");
                    workerType = "Employee";
                } else if (checkedId == R.id.rb_dailyWage) {
                    layoutEmployeeInfo.setVisibility(View.GONE);
                    layoutDailyWageInfo.setVisibility(View.VISIBLE);
                    txtEmployeeHeading.setText("Visitor ID *");
                    workerType = "Visitor";
                }
            }
        });
    }

    public void alertExit(Context con) {
        ViewGroup viewGroup = findViewById(android.R.id.content);

        TextView dialogOkBtn, dialogCancelBtn;

        AlertDialog.Builder builder = new AlertDialog.Builder(con);
        View view1 = LayoutInflater.from(con).inflate(R.layout.custom_layout_for_exit, viewGroup, false);
        builder.setCancelable(false);
        builder.setView(view1);

        dialogOkBtn = view1.findViewById(R.id.dialogOkBtn);
        dialogCancelBtn = view1.findViewById(R.id.dialogCancelBtn);

        AlertDialog alertDialog = builder.create();
        alertDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));

        dialogOkBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                alertDialog.dismiss();

                StorageManager.getInstance().clearInjuryRecordModule();
                finish();

            }
        });

        dialogCancelBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                alertDialog.dismiss();

            }
        });

        alertDialog.show();
    }

    private void initializeLayouts() {

        btnNext = findViewById(R.id.btn_next);
        btnFetch = findViewById(R.id.btn_fetch);
        etEmpId = findViewById(R.id.et_employee_id_number);

        layoutEmployeeInfo = findViewById(R.id.layout_employee_info);
        layoutDailyWageInfo = findViewById(R.id.layout_dailyWage_info);

        layoutEmployeeInfo.setVisibility(View.VISIBLE);
        layoutDailyWageInfo.setVisibility(View.GONE);
        workerType = "Employee";
        StorageManager.getInstance().getInjuryRecordModel().get(0).setWorkerType("Employee/Contractor-Worker");

        txtEmployeeHeading = findViewById(R.id.txt_employee_heading);

        etEmployeeName = findViewById(R.id.et_employee_name);
        etEmployeeDesignation = findViewById(R.id.et_employee_designation);
        etEmployeeTenure = findViewById(R.id.et_employee_tenure);
        imgBack = findViewById(R.id.img_back);
        etEmployeeType = findViewById(R.id.et_employee_type);
        etDate = findViewById(R.id.et_date);

        etLocationSite = findViewById(R.id.et_location_site);
        etCnic = findViewById(R.id.et_cnic);
        etContractorName = findViewById(R.id.et_contractor_name);
        etDivision = findViewById(R.id.et_division);
        etName = findViewById(R.id.et_name);

        rg1 = findViewById(R.id.rg1);
        rbEmployee = findViewById(R.id.rb_employee);
        rbDailyWage = findViewById(R.id.rb_dailyWage);

        loginViewModel = new ViewModelProvider(this).get(LoginViewModel.class);

        loginViewModel.getLoadingState().observe(this, isLoading -> {

            if (isLoading != null && isLoading) {
                showProgressDialog();
            } else {
                dismissProgressDialog();
            }
        });

        loginViewModel.getErrorMessage().observe(this, errorResponse -> {
            if (errorResponse.isEmpty()) {
                Toast.makeText(this, "Something went wrong", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(this, errorResponse, Toast.LENGTH_SHORT).show();
            }
        });

        loginViewModel.getEmployeeLiveData().observe(this, employeeInfoResponse -> {
            if (employeeInfoResponse != null) {
                Log.e("Employee-Info: ",""+employeeInfoResponse.toString());

                etEmployeeName.setText(employeeInfoResponse.getFullName());
                etEmployeeDesignation.setText(employeeInfoResponse.getPositionTitle());
                etEmployeeTenure.setText(employeeInfoResponse.getEmployeeTenure());
                etDate.setText(employeeInfoResponse.getJoiningDate());
                etEmployeeType.setText(employeeInfoResponse.getWorkerType());

            }
        });

        loginViewModel.getDailyWageLiveData().observe(this, dailyWageInfoResponse -> {
            if (dailyWageInfoResponse != null) {
                Log.e("Daily-Wage-Info: ",""+dailyWageInfoResponse.toString());
                etName.setText(dailyWageInfoResponse.getName());
                etLocationSite.setText(dailyWageInfoResponse.getLocationSite());
                etCnic.setText(dailyWageInfoResponse.getCnic());
                etContractorName.setText(dailyWageInfoResponse.getContractorName());
                etDivision.setText(dailyWageInfoResponse.getDivisionDepartment());
            }
        });
    }

    @Override
    public void onBackPressed() {

        alertExit(InjuryFormOne.this);
    }

    public void showProgressDialog() {
        ProgressDialogFragment progressDialog = new ProgressDialogFragment();
        progressDialog.setCancelable(false);
        progressDialog.show(getSupportFragmentManager(), "progressDialog");
    }

    public void dismissProgressDialog() {
        ProgressDialogFragment progressDialog = (ProgressDialogFragment)
                getSupportFragmentManager().findFragmentByTag("progressDialog");
        if (progressDialog != null) {
            progressDialog.dismiss();
        }
    }

    public boolean isValidate() {
        boolean returnValue = true;
        String message = "";

        if (etEmpId.getText().toString().isEmpty()) {
            message = "ID is required.";
            returnValue = false;
        }

        if (!returnValue) {
            Toast.makeText(this, message, Toast.LENGTH_SHORT).show();
        }

        return returnValue;
    }
}