package com.utopiaindustries.hseobservationsapp.activities.InjuryRecordForms;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.utopiaindustries.hseobservationsapp.R;
import com.utopiaindustries.hseobservationsapp.adapters.BodyPartAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.IncidentTypeAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.InjuryTypeAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.KpiAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.PersonalIllnessAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.ShiftAdapter;
import com.utopiaindustries.hseobservationsapp.helper.Helper;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseIncidentType;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseInjuredBodyPart;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseInjury;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseInjuryType;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseKpi;
import com.utopiaindustries.hseobservationsapp.models.HseData.Shift;
import com.utopiaindustries.hseobservationsapp.utils.StorageManager.StorageManager;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

public class InjuryFormTwo extends AppCompatActivity {

    TextView headingIllness;
    Button btnNext;
    ImageView imgBack;
    private AutoCompleteTextView kpiTextview, incidentTypeTextview,
            injuryTypeTextview, personalIllnessTextview, bodyPartTextview, riskTypeTextview ;
    String kpi = "";
    String incidentType = "";
    private ShiftAdapter shiftAdapter;

    private KpiAdapter kpiAdapter;
    private ArrayList<HseKpi> kpiArrayList = new ArrayList<>();

    private ArrayList<HseIncidentType> incidentTypeArrayList = new ArrayList<>();
    private IncidentTypeAdapter incidentTypeAdapter;


    private ArrayList<Shift> riskTypeArrayList = new ArrayList<>();
    private ShiftAdapter riskTypeAdapter;

    private ArrayList<HseInjury> personalIllnessArrayList_temp = new ArrayList<>();
    private ArrayList<HseInjury> personalIllnessArrayList = new ArrayList<>();
    private PersonalIllnessAdapter personalIllnessAdapter;

    private ArrayList<HseInjuryType> injuryTypeArrayList = new ArrayList<>();
    private InjuryTypeAdapter injuryTypeAdapter;
    //private ShiftAdapter injuryTypeAdapter;

    private ArrayList<HseInjuredBodyPart> bodyPartArrayList = new ArrayList<>();
    private BodyPartAdapter bodyPartAdapter;

    String hseInjury = "";
    LinearLayout layoutAccident, layoutInjury, layoutBodyParts;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_injury_form_two);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        //Type of injury --- Type of incidents
        //Near Miss, Property Damage, Fire, RTA -- risk type dropdown(Major, minor)

        //Pictures, description
        //--------------------------------

        //Personal illness -- Type of personal illness dropdown, risk dropdown(major minor),

        // pictuers, description
        //---------------------------------

        //Accident -- Type of Accident, injury Type, body part dropdowns, risk dropdown(major minor),

        // pictuers, description
        //-----------------------------------

        initializeLayouts();

        imgBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        kpiTextview.setOnItemClickListener((v, position, id, item) -> {
            kpi = kpiArrayList.get(id).getTitle();
            StorageManager.getInstance().getInjuryRecordModel().get(0).setKpiId(kpiArrayList.get(id).getId());
            StorageManager.getInstance().getInjuryRecordModel().get(0).setKpiName(kpi);
        });

        incidentTypeTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                HseIncidentType clickedItem = incidentTypeArrayList.get(position);
                incidentType = clickedItem.getTitle();
                int selectedId = clickedItem.getId();
                StorageManager.getInstance().getInjuryRecordModel().get(0).setIncidentId(selectedId);
                StorageManager.getInstance().getInjuryRecordModel().get(0).setIncidentName(clickedItem.getTitle());

                //clear old values
                StorageManager.getInstance().getInjuryRecordModel().get(0).setInjuryId(0);
                StorageManager.getInstance().getInjuryRecordModel().get(0).setInjuryName("");
                StorageManager.getInstance().getInjuryRecordModel().get(0).setInjuryTypeId(0);
                StorageManager.getInstance().getInjuryRecordModel().get(0).setInjuryTypeName("");
                StorageManager.getInstance().getInjuryRecordModel().get(0).setBodyPartId(0);
                StorageManager.getInstance().getInjuryRecordModel().get(0).setBodyPartName("");
                //Near Miss = 1, Property Damage = 2, Fire = 5, RTA = 6
                //Personal Illness = 4
                //Accident = 3
                //
                switch (selectedId) {
                    case 1:
                    case 2:
                    case 5:
                    case 6:
                        headingIllness.setText("Type of Personal illness *");
                        layoutAccident.setVisibility(View.GONE);
                        layoutInjury.setVisibility(View.GONE);
                        layoutBodyParts.setVisibility(View.GONE);

                        personalIllnessTextview.setText(null);
                        injuryTypeTextview.setText(null);
                        bodyPartTextview.setText(null);

                        break;

                    case 3:
                        headingIllness.setText("Type Of Accident *");
                        layoutAccident.setVisibility(View.VISIBLE);
                        layoutInjury.setVisibility(View.VISIBLE);
                        layoutBodyParts.setVisibility(View.VISIBLE);

                        personalIllnessTextview.setText(null);
                        injuryTypeTextview.setText(null);
                        bodyPartTextview.setText(null);
                        break;

                    case 4:
                        headingIllness.setText("Type of Personal illness *");
                        layoutAccident.setVisibility(View.VISIBLE);
                        layoutInjury.setVisibility(View.GONE);
                        layoutBodyParts.setVisibility(View.GONE);

                        personalIllnessTextview.setText(null);
                        injuryTypeTextview.setText(null);
                        bodyPartTextview.setText(null);

                        break;

                    default:
                        headingIllness.setText("Type of Personal illness *");

                }

                personalIllnessTextview.setText(null);

                if (!personalIllnessArrayList_temp.isEmpty()) {

                    List<HseInjury> filteredUnitItems = personalIllnessArrayList_temp.stream()
                            .filter(item -> Objects.equals(item.getIncidentId(), clickedItem.getId()))
                            .collect(Collectors.toList());

                    personalIllnessArrayList.clear();
                    personalIllnessArrayList.addAll(filteredUnitItems);
                    personalIllnessAdapter = new PersonalIllnessAdapter(InjuryFormTwo.this, filteredUnitItems);
                    personalIllnessTextview.setAdapter(personalIllnessAdapter);

                }
            }
        });

        personalIllnessTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                hseInjury = personalIllnessArrayList.get(position).getTitle();
                StorageManager.getInstance().getInjuryRecordModel().get(0).setInjuryId(personalIllnessArrayList.get(position).getId());
                StorageManager.getInstance().getInjuryRecordModel().get(0).setInjuryName(personalIllnessArrayList.get(position).getTitle());

            }
        });

        riskTypeTextview.setOnItemClickListener((v, position, id, item) -> {
            StorageManager.getInstance().getInjuryRecordModel().get(0).setRiskLevel(riskTypeArrayList.get(id).getTitle());
        });

        btnNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (isValidate()) {
                    Intent intent = new Intent(InjuryFormTwo.this, InjuryFormThree.class);
                    startActivity(intent);
                    overridePendingTransition(R.anim.slide_in_right, R.anim.slide_out_left);
                }

            }
        });

        injuryTypeTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                StorageManager.getInstance().getInjuryRecordModel().get(0).setInjuryTypeId(injuryTypeArrayList.get(position).getId());
                StorageManager.getInstance().getInjuryRecordModel().get(0).setInjuryTypeName(injuryTypeArrayList.get(position).getTitle());
            }
        });

        bodyPartTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                StorageManager.getInstance().getInjuryRecordModel().get(0).setBodyPartId(bodyPartArrayList.get(position).getId());
                StorageManager.getInstance().getInjuryRecordModel().get(0).setBodyPartName(bodyPartArrayList.get(position).getTitle());
            }
        });
    }

    private void initializeLayouts() {

        headingIllness = findViewById(R.id.heading_illness);
        btnNext = findViewById(R.id.btn_next);
        imgBack = findViewById(R.id.img_back);
        kpiTextview = findViewById(R.id.kpi_textview);
        injuryTypeTextview = findViewById(R.id.injury_type_textview);
        incidentTypeTextview = findViewById(R.id.incident_type_textview);
        riskTypeTextview = findViewById(R.id.risk_type_textview);
        personalIllnessTextview = findViewById(R.id.personal_illness_textview);
        bodyPartTextview = findViewById(R.id.body_part_textview);

        layoutAccident = findViewById(R.id.layout_accident);
        layoutInjury = findViewById(R.id.layout_injury);
        layoutBodyParts = findViewById(R.id.layout_body_parts);

        showLayouts();

        //kpi -----------
        kpiArrayList.addAll(Helper.getList(Helper.hseKpis, this, HseKpi.class));
        kpiAdapter = new KpiAdapter(this, kpiArrayList);
        kpiTextview.setAdapter(kpiAdapter);

        //incident type ------------
        incidentTypeArrayList.addAll(Helper.getList(Helper.hseIncidentTypes, this, HseIncidentType.class));
        incidentTypeAdapter = new IncidentTypeAdapter(this, incidentTypeArrayList);
        incidentTypeTextview.setAdapter(incidentTypeAdapter);

        //personal illness -----------
        personalIllnessArrayList_temp.addAll(Helper.getList(Helper.hseInjuries, this, HseInjury.class));

        //Injury Type
        injuryTypeArrayList.addAll(Helper.getList(Helper.hseInjuryTypes, this, HseInjuryType.class));
        injuryTypeAdapter = new InjuryTypeAdapter(this, injuryTypeArrayList);
        injuryTypeTextview.setAdapter(injuryTypeAdapter);

        //body part
        bodyPartArrayList.addAll(Helper.getList(Helper.hseInjuredBodyPart, this, HseInjuredBodyPart.class));
        bodyPartAdapter = new BodyPartAdapter(this, bodyPartArrayList);
        bodyPartTextview.setAdapter(bodyPartAdapter);

        //risk type
        riskTypeArrayList.add(new Shift(1, "Major"));
        riskTypeArrayList.add(new Shift(2, "Minor"));

        riskTypeAdapter = new ShiftAdapter(this, riskTypeArrayList);
        riskTypeTextview.setAdapter(riskTypeAdapter);
    }

    @Override
    protected void onResume() {
        super.onResume();

        if (StorageManager.getInstance().getInjuryRecordModel() != null && !StorageManager.getInstance().getInjuryRecordModel().isEmpty()) {
            showPersistData();
        }
    }

    public boolean isValidate() {
        boolean returnValue = true;
        String message = "";

        if (incidentType.isEmpty()) {
            message = "Please select incident type.";
            returnValue = false;
        }

        if (kpi.isEmpty()) {
            message = "Please select KPI.";
            returnValue = false;
        }

        if (!returnValue) {
            Toast.makeText(this, message, Toast.LENGTH_SHORT).show();
        }

        return returnValue;
    }

    private void showPersistData() {
        kpiTextview.post(() -> kpiTextview.setText(StorageManager.getInstance().getInjuryRecordModel().get(0).getKpiName(), false));
        kpi = StorageManager.getInstance().getInjuryRecordModel().get(0).getKpiName();
        incidentTypeTextview.post(() -> incidentTypeTextview.setText(StorageManager.getInstance().getInjuryRecordModel().get(0).getIncidentName(), false));
        incidentType = StorageManager.getInstance().getInjuryRecordModel().get(0).getIncidentName();
        personalIllnessTextview.post(() -> personalIllnessTextview.setText(StorageManager.getInstance().getInjuryRecordModel().get(0).getInjuryName(), false));
        injuryTypeTextview.post(() -> injuryTypeTextview.setText(StorageManager.getInstance().getInjuryRecordModel().get(0).getInjuryTypeName(), false));
        bodyPartTextview.post(() -> bodyPartTextview.setText(StorageManager.getInstance().getInjuryRecordModel().get(0).getBodyPartName(), false));
        riskTypeTextview.post(() -> riskTypeTextview.setText(StorageManager.getInstance().getInjuryRecordModel().get(0).getRiskLevel(), false));

        showLayouts();

        if (!personalIllnessArrayList_temp.isEmpty()) {

            List<HseInjury> filteredUnitItems = personalIllnessArrayList_temp.stream()
                    .filter(item -> Objects.equals(item.getIncidentId(), StorageManager.getInstance().getInjuryRecordModel().get(0).getIncidentId()))
                    .collect(Collectors.toList());

            personalIllnessArrayList.clear();
            personalIllnessArrayList.addAll(filteredUnitItems);
            personalIllnessAdapter = new PersonalIllnessAdapter(InjuryFormTwo.this, filteredUnitItems);
            personalIllnessTextview.setAdapter(personalIllnessAdapter);

        }

    }

    private void showLayouts() {
        if (StorageManager.getInstance().getInjuryRecordModel().get(0).getIncidentName() != null
                && !StorageManager.getInstance().getInjuryRecordModel().get(0).getIncidentName().isEmpty()) {
            switch (StorageManager.getInstance().getInjuryRecordModel().get(0).getIncidentName()) {
                case "Near Miss":
                case "Property Damage":
                case "RTA":
                case "Fire":
                    headingIllness.setText("Type of Personal illness *");
                    layoutAccident.setVisibility(View.GONE);
                    layoutInjury.setVisibility(View.GONE);
                    layoutBodyParts.setVisibility(View.GONE);

                    personalIllnessTextview.setText(null);
                    injuryTypeTextview.setText(null);
                    bodyPartTextview.setText(null);

                    break;

                case "Accident":
                    headingIllness.setText("Type Of Accident *");
                    layoutAccident.setVisibility(View.VISIBLE);
                    layoutInjury.setVisibility(View.VISIBLE);
                    layoutBodyParts.setVisibility(View.VISIBLE);

                    personalIllnessTextview.setText(null);
                    injuryTypeTextview.setText(null);
                    bodyPartTextview.setText(null);
                    break;

                case "Personal Illness":
                    headingIllness.setText("Type of Personal illness *");
                    layoutAccident.setVisibility(View.VISIBLE);
                    layoutInjury.setVisibility(View.GONE);
                    layoutBodyParts.setVisibility(View.GONE);

                    personalIllnessTextview.setText(null);
                    injuryTypeTextview.setText(null);
                    bodyPartTextview.setText(null);

                    break;

                default:
                    headingIllness.setText("Type of Personal illness *");

            }
        }
    }
}