package com.utopiaindustries.hseobservationsapp.activities.ObservationForms;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.utopiaindustries.hseobservationsapp.R;
import com.utopiaindustries.hseobservationsapp.activities.DashboardActivity;
import com.utopiaindustries.hseobservationsapp.adapters.ObservationClassAdapter;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseObservationClass;

import java.util.ArrayList;

public class ObservationNearMissActivity extends AppCompatActivity {

    private AutoCompleteTextView observationTextview;
    private ObservationClassAdapter observationClassAdapter;
    private ArrayList<HseObservationClass> obClassArrayList = new ArrayList<>();

    private Button btnSubmit;
    ImageView imgBack;

    String observationClass = "";
    EditText etDescription;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_observation_near_miss);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initializeLayout();

        imgBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        btnSubmit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
               /* if (isValidate()) {

                }*/
                Intent intent = new Intent(ObservationNearMissActivity.this, DashboardActivity.class);
               // intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK);
                intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK);
                startActivity(intent);
                finish();
                overridePendingTransition(R.anim.slide_in_right, R.anim.slide_out_left);
            }
        });

        observationTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                // Perform action when shiftTextview item is clicked
                //Toast.makeText(ObservationNearMissActivity.this, "Item clicked: " + obClassArrayList.get(position).getTitle(), Toast.LENGTH_SHORT).show();

            }
        });
    }

    public void initializeLayout() {
        observationTextview = findViewById(R.id.observation_near_textview);
        btnSubmit = findViewById(R.id.btn_submit);
        imgBack = findViewById(R.id.img_back);
        etDescription = findViewById(R.id.et_description);

        /*obClassArrayList.add(new Shift(1, "Option 1"));
        obClassArrayList.add(new Shift(2, "Option 2"));
        obClassArrayList.add(new Shift(3, "Option 3"));*/

        observationClassAdapter = new ObservationClassAdapter(this, obClassArrayList);
        observationTextview.setAdapter(observationClassAdapter);

    }

    public boolean isValidate() {
        boolean returnValue = true;
        String message = "";

        if (etDescription.getText().toString().isEmpty()) {
            message = "Please enter description.";
            returnValue = false;
        }

        if (observationClass.isEmpty()) {
            message = "Please select Location.";
            returnValue = false;
        }

        if (!returnValue) {
            Toast.makeText(this, message, Toast.LENGTH_SHORT).show();
        }

        return returnValue;
    }
}