package com.utopiaindustries.hseobservationsapp.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.utopiaindustries.hseobservationsapp.R;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseBuilding;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseDepartment;

import java.util.List;

public class BuildingsAdapter extends ArrayAdapter<HseBuilding> {

    private final Context context;
    private final List<HseBuilding> items;

    public BuildingsAdapter(Context context, List<HseBuilding> items) {
        super(context, 0, items);
        this.context = context;
        this.items = items;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.list_items, parent, false);
        }

        HseBuilding item = items.get(position);

        TextView titleTextView = convertView.findViewById(R.id.item_text);

        titleTextView.setText(item.getTitle());

        return convertView;
    }
}
