package com.utopiaindustries.hseobservationsapp.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.utopiaindustries.hseobservationsapp.R;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseIncidentType;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseInjury;

import java.util.List;

public class PersonalIllnessAdapter extends ArrayAdapter<HseInjury> {

    private final Context context;
    private final List<HseInjury> items;

    public PersonalIllnessAdapter(Context context, List<HseInjury> items) {
        super(context, 0, items);
        this.context = context;
        this.items = items;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.list_items, parent, false);
        }

        HseInjury item = items.get(position);

        TextView titleTextView = convertView.findViewById(R.id.item_text);

        titleTextView.setText(item.getTitle());

        return convertView;
    }
}
