package com.utopiaindustries.hseobservationsapp.helper;

import android.content.Context;
import android.content.SharedPreferences;

public class Preference {

	private static final int PREFERENCE_MODE_PRIVATE = 0;
	private static String MY_STRING_PREF = "mystringpref";
	public static String LOGIN_FILE = "login_prefs";
	public static String TEMP_FILE = "temp_prefs";


	public static String KEY_PIN_CODE = "pin_code";

	public static String KEY_CUSTOMER_ID = "cus_id";
	public static String KEY_CUSTOMER_NAME = "cus_name";

	public static String KEY_USER_IS_MASTER = "user_is_master";

	public static SharedPreferences getPrefs(String nameOfFile, Context context) {

		return context.getSharedPreferences(nameOfFile, Context.MODE_PRIVATE);
	}

	public static boolean containsKey(String fileName, String key, Context context) {
		return getPrefs(fileName, context).contains(key);
	}

	public static String getMyStringPref(String fileName, String key, Context context) {

		return getPrefs(fileName,context).getString(key, "default");
	}
	public static boolean getMyBooleanPref(String fileName, String key, Context context) {

		return getPrefs(fileName,context).getBoolean(key,false);
	}
	public static int getMyIntPref(String fileName, String key, Context context) {

		return getPrefs(fileName,context).getInt(key, 0);
	}

	public static long getMyLongPref(String fileName, String key, Context context) {

		return getPrefs(fileName,context).getLong(key, 0);
	}

	public static void setMyLongPref(String fileName, String key, Context context, long value) {
		// perform validation etc..
		getPrefs(fileName,context).edit().putLong(key, value).apply();
	}

	public static void setMyStringPref(String fileName, String key, Context context, String value) {
		// perform validation etc..
		getPrefs(fileName,context).edit().putString(key, value).apply();
	}

	public static void setMyBooleanPref(String fileName, String key, Context context, boolean value) {
		// perform validation etc..
		getPrefs(fileName,context).edit().putBoolean(key, value).apply();
	}

	public static void setMyIntPref(String fileName, String key, Context context, int value) {
		// perform validation etc..
		getPrefs(fileName,context).edit().putInt(key, value).apply();
	}
	
	
	public static void remove(String fileName, String key, Context context) {
		// perform validation etc..
		if (context != null) {
			if (getPrefs(fileName,context).contains(key)) {
				getPrefs(fileName,context).edit().remove(key).apply();
			}
		}

	}
	public static void removeAll(String fileName, Context context) {
		// perform validation etc..
		getPrefs(fileName,context).edit().clear().apply();
	}
}
